﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@

Sub Class_Globals
	
	Type  cTFilePickerResult(Completed As Boolean, IsValid As Boolean, FullFileName As String, FilePath As String, FileName As String)
	
	Private		mFilePickerResult							As cTFilePickerResult
		
	Private		mActivity									As Activity

    Private     mAlertBeeper      							As Beeper
	
	Private 	mCurrentPath								As String
	Private		mWildCard									As String
	
	Private		mFilePickedInitText							As String = "< pick a file >"

	Private		mLastSelected								As Label
	Private		mFilesList									As List
	Private		mDirectoriesList							As List
	
	Private		sFP_Overlay									As Panel
	Private			sFP_Main								As Panel
	Private				sFP_PickMsg							As Label
	Private				sFP_Picked							As Label
	Private				sFP_FileList						As ScrollView
	Private				sFP_Cancel							As Button
	Private				sFP_OK								As Button


	Public		IsShowing									As Boolean	= False
	Public		sFP_ShowLogMsgs								As Boolean	= False
	
		
	'------------------------------------------------------------------------------------------------------------
	'		Cancel Overal Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_Overlay_Color							As Int		= Colors.Transparent
		
	'------------------------------------------------------------------------------------------------------------
	'		Main Panel Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_Main_Color								As Int		= Colors.Gray
	Public		sFP_Main_Radius								As Int		=  5dip
	Public		sFP_Main_BorderColor						As Int		= Colors.Gray	
	Public		sFP_Main_BorderWidth						As Int		=  0dip
	
	Public		sFP_Main_Width								As Float	= .90								'	.90 = 90%
	Public		sFP_Main_Left								As Float	= (1.00 - sFP_Main_Width)  / 2		'  1.00 - .90 / 2 = 5% 	
	Public		sFP_Main_Height								As Float	= .90
	Public		sFP_Main_Top 								As Float	= (1.00 - sFP_Main_Height) / 2
	
	Public		sFP_Offset									As Int		= 7dip
		
	'------------------------------------------------------------------------------------------------------------
	'		Cancel Button Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_Cancel_Color							As Int		= Colors.RGB(128, 0, 0)	
	Public		sFP_Cancel_TextColor						As Int		= Colors.White
	Public		sFP_Cancel_BorderColor						As Int		= Colors.Black	
	Public		sFP_Cancel_BorderSelectedColor				As Int		= Colors.White
	Public		sFP_Cancel_Radius							As Int		=  15dip
	Public		sFP_Cancel_BorderWidth						As Int		=   2dip
	Public		sFP_Cancel_Typeface							As Typeface = Typeface.DEFAULT_BOLD
	Public		sFP_Cancel_Gravity							As Int		= Gravity.CENTER
	Public		sFP_Cancel_Padding()						As Int		= Array As Int(0, 0, 0, 0)		
	Public		sFP_Cancel_TextSize							As Int		=  20
	Public		sFP_Cancel_Height							As Int		=  35dip
	Public		sFP_Cancel_Width							As Int		= 125dip

	'------------------------------------------------------------------------------------------------------------
	'		OK Button Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_OK_Color								As Int		= Colors.RGB(0, 128, 0)	
	Public		sFP_OK_TextColor							As Int		= Colors.White
	Public		sFP_OK_BorderColor							As Int		= Colors.Black	
	Public		sFP_OK_BorderSelectedColor					As Int		= Colors.White
	Public		sFP_OK_Radius								As Int		=  15dip
	Public		sFP_OK_BorderWidth							As Int		=   2dip
	Public		sFP_OK_Typeface								As Typeface = Typeface.DEFAULT_BOLD
	Public		sFP_OK_Gravity								As Int		= Gravity.CENTER
	Public		sFP_OK_Padding()							As Int		= Array As Int(0, 0, 0, 0)			
	Public		sFP_OK_TextSize								As Int		=  20
	Public		sFP_OK_Height								As Int		=  35dip
	Public		sFP_OK_Width								As Int		= 125dip
			
	'------------------------------------------------------------------------------------------------------------
	'		FileList (ScrollView) Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_FileList_Color							As Int		= Colors.LightGray
	Public		sFP_FileList_Common_EntryHeight				As Int		= 35dip
	Public		sFP_FileList_Common_TextSize				As Int		= 20

	'------------------------------------------------------------------------------------------------------------
	'		FileList Label Settings
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_FileList_Label_Selected_Color			As Int		= Colors.LightGray
	Public		sFP_FileList_Label_Selected_Radius			As Int		= 0
	Public		sFP_FileList_Label_Selected_BorderWidth		As Int		= 3dip
	Public		sFP_FileList_Label_Selected_BorderColor		As Int		= Colors.Black
	
	Public		sFP_FileList_Label_Unselected_Color			As Int		= Colors.LightGray
	Public		sFP_FileList_Label_Unselected_Radius		As Int		= 0
	Public		sFP_FileList_Label_Unselected_BorderWidth	As Int		= 0dip
	Public		sFP_FileList_Label_Unselected_BorderColor	As Int		= Colors.LightGray

	Public		sFP_FileList_Label_TextColor				As Int		= Colors.Black
	Public		sFP_FileList_Label_TextSize					As Int		= 20
	Public		sFP_FileList_Label_Padding()				As Int		= Array As Int(sFP_FileList_Label_Selected_BorderWidth + 5dip, 0, 0, 0)
	Public		sFP_FileList_Label_Gravity					As Int		= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
	
	'------------------------------------------------------------------------------------------------------------
	'		FileList Seperator
	'------------------------------------------------------------------------------------------------------------
	Public		sFP_FileList_Seperator_Show					As Boolean	= True
	Public		sFP_FileList_Seperator_Color				As Int		= Colors.Black
	Public		sFP_FileList_Seperator_Height				As Int		= 1dip

	'------------------------------------------------------------------------------------------------------------
	'		PickMsg Settings
	'------------------------------------------------------------------------------------------------------------	
	Public		sFP_PickMsg_Color							As Int		= Colors.LightGray
	Public		sFP_PickMsg_TextColor						As Int		= Colors.Black
	Public		sFP_PickMsg_Typeface						As Typeface = Typeface.DEFAULT_BOLD
	Public		sFP_PickMsg_Gravity							As Int		= Gravity.CENTER
	Public		sFP_PickMsg_Padding()						As Int		= Array As Int(5dip, 0, 0, 0)	
	Public		sFP_PickMsg_TextSize						As Int		= 20
	Public		sFP_PickMsg_Height							As Int		= 35dip

	'------------------------------------------------------------------------------------------------------------
	'		Picked Settings
	'------------------------------------------------------------------------------------------------------------	
	Public		sFP_Picked_Color							As Int		= Colors.White
	Public		sFP_Picked_TextColor						As Int		= Colors.Black
	Public		sFP_Picked_Typeface							As Typeface = Typeface.DEFAULT_BOLD
	Public		sFP_Picked_Gravity							As Int		= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
	Public		sFP_Picked_Padding()						As Int		= Array As Int(5dip, 0, 0, 0)	
	Public		sFP_Picked_TextSize							As Int		= 20
	Public		sFP_Picked_Height							As Int		= 35dip
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public  Sub Initialize(Act As Activity)
	
			mActivity		= Act
	
			mFilePickerResult.Initialize
			
	    	mAlertBeeper.Initialize2(500, 500, mAlertBeeper.VOLUME_NOTIFICATION)

			mFilesList.Initialize
			mDirectoriesList.Initialize		
	
			sFP_Overlay.Initialize("sFP_Overlay")
			sFP_Main.Initialize("sFP_Main")
			
			sFP_PickMsg.Initialize("")
			sFP_Picked.Initialize("")
			
			sFP_FileList.Initialize(40dip)
			
			sFP_Cancel.Initialize("sFP_Cancel")
			sFP_OK.Initialize("sFP_OK")			
End Sub

Private Sub sFP_Overlay_Touch(Action As Int, X As Float, Y As Float)  As Boolean
			If  sFP_ShowLogMsgs Then
				Log("sFP_Overlay_Touch")						
			End If
			
	    	Return False
End Sub

#region MakeColorDrawable / MakeScrollLineBackground
Public  Sub MakeColorDrawable(BackgroundColor As Int, CornerRadius As Int, BorderWidth As Int, BorderColor As Int) As ColorDrawable
	
			Dim MakeCD As ColorDrawable

			MakeCD.Initialize2(BackgroundColor, CornerRadius, BorderWidth, BorderColor)
	
			Return MakeCD
End Sub	

Private Sub MakeScrollLineBackground(Color As Int, Radius As Int, BorderWidth As Int, BorderColor As Int) As ColorDrawable
			
			Return MakeColorDrawable(Color, Radius, BorderWidth, BorderColor)				
End Sub
#end region

#region ConfigureView
Public  Sub ConfigureView(View As Object, Text As String, TextSize As Int, Color As Int, TextColor As Int, DisplayTypeFace As Typeface, DisplayGravity As Int, Padding() As Int)
	
			If  View Is Label Then
				Dim vLabel As Label = View

				vLabel.Text			= 	Text
				vLabel.TextColor	= 	TextColor
				vLabel.TextSize		= 	TextSize
				vLabel.Typeface		=	DisplayTypeFace
				vLabel.Gravity		=	DisplayGravity			
				vLabel.Color		=	Color			
				vLabel.Padding		= 	Padding
			Else if View Is Button Then
				Dim vButton As Button = View

				vButton.Text		= 	Text
				vButton.TextColor	= 	TextColor
				vButton.TextSize	=	TextSize
				vButton.Typeface	=	DisplayTypeFace
				vButton.Gravity		=	DisplayGravity			
				vButton.Color		=	Color			
				vButton.Padding		= 	Padding				
			End If
End Sub

Public  Sub ConfigureView2(View As Object, Text As String, TextSize As Int, Background As ColorDrawable, BackgroundPressed As ColorDrawable, TextColor As Int, DisplayTypeFace As Typeface, DisplayGravity As Int, Padding() As Int)
	
			ConfigureView(View, Text, TextSize, Colors.Transparent, TextColor, DisplayTypeFace, DisplayGravity, Padding)
						
					
		   	Dim StateListBackground As StateListDrawable
		   
    		StateListBackground.Initialize

			If  BackgroundPressed <> Null Then    
				StateListBackground.AddState(StateListBackground.State_Pressed, BackgroundPressed)
			Else
				StateListBackground.AddState(StateListBackground.State_Pressed,	Background)				
			End If
			
    		StateListBackground.AddState(StateListBackground.State_Enabled, Background)
						
			If  View Is Label Then
				Dim vLabel As Label = View

				vLabel.Background	= 	StateListBackground
			Else if View Is Button Then
				Dim vButton As Button = View

				vButton.Background	= 	StateListBackground
			End If
End Sub
#end Region

#Region SetupColors
Private Sub SetupColors
			
			sFP_Overlay.Color			= 	sFP_Overlay_Color
			
			sFP_Main.Background			= 	MakeColorDrawable(sFP_Main_Color, sFP_Main_Radius, sFP_Main_BorderWidth, sFP_Main_BorderColor)
			
			sFP_FileList.Color			=	sFP_FileList_Color

			ConfigureView(sFP_PickMsg, 	"Pick file", sFP_PickMsg_TextSize, 	sFP_PickMsg_Color, 	sFP_PickMsg_TextColor, 	sFP_PickMsg_Typeface, 	sFP_PickMsg_Gravity,	sFP_PickMsg_Padding)
			ConfigureView(sFP_Picked, 	"",			 sFP_Picked_TextSize,	sFP_Picked_Color, 	sFP_Picked_TextColor, 	sFP_Picked_Typeface, 	sFP_Picked_Gravity, 	sFP_Picked_Padding)

			ConfigureView2(sFP_Cancel, "Cancel", sFP_Cancel_TextSize,		MakeColorDrawable(sFP_Cancel_Color, sFP_Cancel_Radius, sFP_OK_BorderWidth, sFP_Cancel_BorderColor), 			_
																			MakeColorDrawable(sFP_Cancel_Color, sFP_Cancel_Radius, sFP_OK_BorderWidth, sFP_Cancel_BorderSelectedColor), 	_
												 							sFP_Cancel_BorderSelectedColor, sFP_Cancel_Typeface, sFP_Cancel_Gravity, sFP_Cancel_Padding)

			ConfigureView2(sFP_OK, 	   "OK",	 sFP_OK_TextSize,			MakeColorDrawable(sFP_OK_Color, sFP_OK_Radius, sFP_OK_BorderWidth, sFP_OK_BorderColor), 			_
												 							MakeColorDrawable(sFP_OK_Color, sFP_OK_Radius, sFP_OK_BorderWidth, sFP_OK_BorderSelectedColor), 	_
												 							sFP_OK_BorderSelectedColor, sFP_OK_Typeface, sFP_OK_Gravity, sFP_OK_Padding)
End Sub
#End Region

#Region EndShow - Same as user clicking Cancel
'  EndShowing(Force as Boolean) 
'     Force FilePicker to CleanUp Views
Public  Sub EndShowing(Force As Boolean)
			sFP_Cancel_Click
			
			If  Force Then 
				DoneShowing
			End If
End Sub
#end Region

#Region ShowFiles
Public  Sub ShowFiles(Path As String, FileList As String, LastPicked As String, PickMsg As String, CancelButton As String, OKButton As String) 
	
			SetupColors
				
			mActivity.AddView(sFP_Overlay, 0, 0, 100%x, 100%y)
			
			'-------------------------------------------------------------------------------------------------------------
			'  Using percentages of x and y for screen size
			'-------------------------------------------------------------------------------------------------------------
			sFP_Overlay.AddView(sFP_Main, (100%x * sFP_Main_Left), (100%y * sFP_Main_Top), (100%x * sFP_Main_Width), (100%y * sFP_Main_Height))
			
			sFP_Main.AddView(sFP_PickMsg, 	sFP_Offset,  sFP_Offset, 						sFP_Main.Width - (sFP_Offset * 2), sFP_PickMsg_Height)
			sFP_Main.AddView(sFP_Picked,  	sFP_Offset, (sFP_Offset + sFP_PickMsg_Height), 	sFP_Main.Width - (sFP_Offset * 2), sFP_Picked_Height)
			
			sFP_Main.AddView(sFP_Cancel,    sFP_Offset, 									sFP_Main.Height - (sFP_Cancel_Height + sFP_Offset), sFP_Cancel_Width, 	sFP_Cancel_Height)
			sFP_Main.AddView(sFP_OK,	   (sFP_Main.Width - (sFP_OK_Width + sFP_Offset)), 	sFP_Main.Height - (sFP_OK_Height + sFP_Offset), 	sFP_OK_Width, 		sFP_OK_Height)
			
			sFP_Main.AddView(sFP_FileList,  sFP_Offset, (sFP_PickMsg_Height + sFP_Picked_Height + sFP_Offset), (sFP_Main.Width - (sFP_Offset * 2)), (sFP_Cancel.Top - ((sFP_PickMsg_Height + sFP_Picked_Height + sFP_Offset + 5dip))))
						
						
			If  PickMsg.Length 		> 0 Then  	sFP_PickMsg.Text	= PickMsg
			If	CancelButton.Length > 0 Then	sFP_Cancel.Text		= CancelButton
			If	OKButton.Length		> 0	Then	sFP_OK.Text			= OKButton
			
			'-------------------------------------------------------------------------------
			'  In case a Path ending with a Slash is passed
			'-------------------------------------------------------------------------------
			If  Path.Length > 0 Then
				If  Path.CharAt(Path.Length-1) = "/" Then
					Path = Path.SubString2(0, Path.Length-1)
				End If
			End If
			
			mCurrentPath 	= Path
			mWildCard	 	= FileList
			
			sFP_Picked.Text	= mFilePickedInitText
			
			If  LastPicked.Length > 0 Then
				sFP_Picked.Text = LastPicked
			End If
			
			IsShowing						= True
			
			mFilePickerResult.IsValid		= False
			mFilePickerResult.Completed		= False
			mFilePickerResult.FullFileName 	= ""
			mFilePickerResult.FilePath	 	= ""
			mFilePickerResult.FileName 		= ""
			
			ListFilesAndFolders(mCurrentPath, False, mWildCard, True, True)
End Sub

Public  Sub ShowAndWait(Path As String, FileList As String, LastPicked As String, PickMsg As String, CancelButton As String, OKButton As String) As ResumableSub
			ShowFiles(Path, FileList, LastPicked, PickMsg, CancelButton, OKButton) 
	
			Do While mFilePickerResult.Completed = False
				Sleep(0)
			Loop			
			
			DoneShowing
			
			Return mFilePickerResult		
End Sub

Public  Sub WaitForResult As ResumableSub
						
			If  IsShowing Then						
				Do While mFilePickerResult.Completed = False
					Sleep(0)
				Loop			
			End If
			
			DoneShowing
			
			Return mFilePickerResult	
End Sub

Private Sub DoneShowing
			IsShowing = False
						
			sFP_Overlay.RemoveView
			sFP_Overlay.RemoveAllViews

			sFP_Main.RemoveView		
			
			sFP_PickMsg.RemoveView
			sFP_Picked.RemoveView
			
			sFP_FileList.RemoveView
			sFP_FileList.Panel.RemoveAllViews
			
			sFP_Cancel.RemoveView
			sFP_OK.RemoveView		
						
			Return
End Sub
#end Region

#Region LoadScrollView
Private Sub LoadScrollView
	
			Dim  EntryHeight	As Int	= sFP_FileList_Common_EntryHeight
			Dim  Height 		As Int	= 0
			
			Dim  FileName		As String
			Dim	 Directory		As String
			
			Dim	 LastSlash		As Int
			Dim  IncludeDotDot  As Boolean = mCurrentPath.Contains("/")

			
			mLastSelected.Initialize("")
			
			
			sFP_FileList.Panel.RemoveAllViews
			
			
			'-----------------------------------------------------------------------------------
			'  Do we need to include a Dot Dot if nothing above us then no
			'-----------------------------------------------------------------------------------
			If  IncludeDotDot Then
				Dim DotDotLabel As Label
				
				DotDotLabel.Initialize("FP_DotDot")
				DotDotLabel.Color		= Colors.LightGray
				DotDotLabel.TextColor	= Colors.Black
				DotDotLabel.Text		= Chr(0xF177) &" .."
				DotDotLabel.Typeface	= Typeface.FONTAWESOME							
				DotDotLabel.Padding		= Array As Int(5dip, 0, 0, 0)
				DotDotLabel.Gravity		= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
				DotDotLabel.Tag			= ".."
				DotDotLabel.TextSize	= sFP_FileList_Common_TextSize
							
				sFP_FileList.Panel.AddView(DotDotLabel, 0, Height, sFP_FileList.Width, EntryHeight)
				
				Height = Height + EntryHeight
			End If

			'-----------------------------------------------------------------------------------
			'  Any Files to Display
			'-----------------------------------------------------------------------------------
			If  mFilesList.Size > 0 Then
				Dim FilesLabel As Label
				
				FilesLabel.Initialize("")
				FilesLabel.Color		= Colors.DarkGray				
				FilesLabel.TextColor	= Colors.White
				FilesLabel.Typeface		= Typeface.FONTAWESOME			
				FilesLabel.Text			= "  " &Chr(0xF175) &" Files " &Chr(0xF175)
				FilesLabel.Padding		= Array As Int(5dip, 0, 0, 0)
				FilesLabel.Gravity		= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
				FilesLabel.Tag			= ".FL."
				FilesLabel.TextSize		= sFP_FileList_Common_TextSize
							
				sFP_FileList.Panel.AddView(FilesLabel, 0, Height, sFP_FileList.Width, EntryHeight)
			
				Height = Height + EntryHeight
			
				For i = 0 To mFilesList.Size-1
					FileName 	= mFilesList.Get(i)

					LastSlash 	= FileName.LastIndexOf("/")
				
					Dim FileNameLabel As Label
				
					If  LastSlash <> -1 Then
						FileName = FileName.SubString(LastSlash + 1)
					End If
					
					FileNameLabel.Initialize("FP_FileName")
					FileNameLabel.Background	= MakeScrollLineBackground(sFP_FileList_Label_Unselected_Color, sFP_FileList_Label_Unselected_Radius, sFP_FileList_Label_Unselected_BorderWidth, sFP_FileList_Label_Unselected_BorderColor)

					FileNameLabel.Text			= FileName					
					FileNameLabel.Tag			= ".FN."
					
					FileNameLabel.TextColor		= sFP_FileList_Label_TextColor
					FileNameLabel.Padding		= sFP_FileList_Label_Padding
					FileNameLabel.Gravity		= sFP_FileList_Label_Gravity
					FileNameLabel.TextSize		= sFP_FileList_Label_TextSize
											
					sFP_FileList.Panel.AddView(FileNameLabel, 0, Height, sFP_FileList.Width, EntryHeight)
			
					Height = Height + EntryHeight					
					
					If  sFP_FileList_Seperator_Show Then						
						If  (i + 1) <> mFilesList.Size Then
							Dim xSeperator As Panel
						
							xSeperator.Initialize("")
							xSeperator.Color	= sFP_FileList_Seperator_Color
					
							sFP_FileList.Panel.AddView(xSeperator, 0, Height, sFP_FileList.Width, sFP_FileList_Seperator_Height)		
					
							Height = Height + sFP_FileList_Seperator_Height						
						End If
					End If
				Next
			End If
			
			'-----------------------------------------------------------------------------------
			'  Any Directories to display
			'-----------------------------------------------------------------------------------
			If  mDirectoriesList.Size > 0 Then
				Dim DirsLabel As Label
					
				DirsLabel.Initialize("")
				DirsLabel.Color			= Colors.DarkGray
				DirsLabel.TextColor		= Colors.White
				DirsLabel.Typeface		= Typeface.FONTAWESOME
				DirsLabel.Text			= "  " &Chr(0xF175) &" Directories " &Chr(0xF175)
				DirsLabel.Padding		= Array As Int(5dip, 0, 0, 0)
				DirsLabel.Gravity		= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
				DirsLabel.Tag			= ".DL."
				DirsLabel.TextSize		= sFP_FileList_Common_TextSize
							
				sFP_FileList.Panel.AddView(DirsLabel, 0, Height, sFP_FileList.Width, EntryHeight)
			
				Height = Height + EntryHeight
			
				For i = 0 To mDirectoriesList.Size-1					
					Directory = mDirectoriesList.Get(i)
					
					LastSlash = Directory.LastIndexOf("/")

					If  LastSlash <> -1 Then
						Directory = Directory.SubString(LastSlash + 1)
					End If

					If  sFP_ShowLogMsgs Then					
						Log("Directory[" &Directory &"]")
					End If
					
					Dim DirLabel As Label
				
					DirLabel.Initialize("FP_Directory")
					DirLabel.Color		= Colors.LightGray
					DirLabel.TextColor	= Colors.Black
					DirLabel.Text		= Directory
					DirLabel.Padding	= Array As Int(5dip, 0, 0, 0)
					DirLabel.Gravity	= Bit.Or(Gravity.LEFT, Gravity.CENTER_VERTICAL)
					DirLabel.Tag		= ".DIR."
					DirLabel.TextSize	= sFP_FileList_Common_TextSize
							
					sFP_FileList.Panel.AddView(DirLabel, 0, Height, sFP_FileList.Width, EntryHeight)
			
					Height = Height + EntryHeight		
					
					If  sFP_FileList_Seperator_Show Then						
						If  (i + 1) <> mDirectoriesList.Size Then
							Dim xSeperator As Panel
						
							xSeperator.Initialize("")
							xSeperator.Color	= sFP_FileList_Seperator_Color
					
							sFP_FileList.Panel.AddView(xSeperator, 0, Height, sFP_FileList.Width, sFP_FileList_Seperator_Height)		
					
							Height = Height + sFP_FileList_Seperator_Height						
						End If
					End If								
				Next
			End If
									
    		sFP_FileList.Panel.Height = Height
			
			Dim jo As JavaObject = sFP_FileList.Panel
			
    	    jo.RunMethod("requestLayout", Null)													
			
    		sFP_FileList.Invalidate			
End Sub
#end Region

#Region FilePicker Click Routines
'---------------------------------------------------------------------------------------------
'		User does not want to select anything
'---------------------------------------------------------------------------------------------
Private Sub sFP_Cancel_Click
			mFilePickerResult.IsValid 		= False			
			mFilePickerResult.FullFileName	= ""
			mFilePickerResult.FilePath	 	= ""
			mFilePickerResult.FileName 		= ""			
			mFilePickerResult.Completed		= True
End Sub

'---------------------------------------------------------------------------------------------
'		If the user picked something then return it.
'---------------------------------------------------------------------------------------------
Private Sub sFP_OK_Click
	
			If  sFP_Picked.Text.Length = 0 Or sFP_Picked.Text = mFilePickedInitText Then
				mAlertBeeper.Beep
				
				ToastMessageShow("Pick an entry or select Cancel", False)
				Return
			End If

			
			mFilePickerResult.IsValid		= True
			mFilePickerResult.FullFileName	= mCurrentPath &"/" &sFP_Picked.Text
			mFilePickerResult.FilePath		= mCurrentPath
			mFilePickerResult.FileName		= sFP_Picked.Text
			mFilePickerResult.Completed		= True
End Sub


#Region File Picker Click Routine
'---------------------------------------------------------------------------------------------
'		The user clicked on Dot Dot
'---------------------------------------------------------------------------------------------
Private Sub FP_DotDot_Click

			Dim  LastSlash 	As Int = mCurrentPath.LastIndexOf("/")
			Dim	 TempPath	As String
			
			If  LastSlash = -1 Then Return
			
			
			TempPath = mCurrentPath.SubString2(0, LastSlash)
			
			If  TempPath.Contains("/") = False Then Return
			
			mCurrentPath = TempPath
			
            ListFilesAndFolders(mCurrentPath, False, mWildCard, True, True)			
End Sub

'---------------------------------------------------------------------------------------------
'		The user clicked on a FileName
'---------------------------------------------------------------------------------------------
Private Sub FP_FileName_Click
			Dim FileNameLabel As Label = Sender

			If  sFP_ShowLogMsgs Then			
				Log("FP_FileName:" &FileNameLabel.Text)
			End If
			
			If  mLastSelected.IsInitialized Then
				mLastSelected.Background = MakeScrollLineBackground(sFP_FileList_Label_Unselected_Color, sFP_FileList_Label_Unselected_Radius, sFP_FileList_Label_Unselected_BorderWidth, sFP_FileList_Label_Unselected_BorderColor)
			End If
			
			mLastSelected			 = FileNameLabel
			mLastSelected.Background = MakeScrollLineBackground(sFP_FileList_Label_Selected_Color, sFP_FileList_Label_Selected_Radius, sFP_FileList_Label_Selected_BorderWidth, sFP_FileList_Label_Selected_BorderColor)
			
			sFP_Picked.Text 		 = FileNameLabel.Text
End Sub			

'---------------------------------------------------------------------------------------------
'		The user clicked on a Diretory
'---------------------------------------------------------------------------------------------
Private Sub FP_Directory_Click
			Dim DirLabel As Label = Sender
			
			If  sFP_ShowLogMsgs Then
				Log("FP_Directory:" &DirLabel.Text)
			End If
			
			mCurrentPath = mCurrentPath &"/" &DirLabel.Text
			
            ListFilesAndFolders(mCurrentPath, False, mWildCard, True, True)			
End Sub			
#end Region
#end region

#region Barrowed WildCardList Routines
'--------------------------------------------------------------------------------------------------------------------------------------
'  	The following two routines we barrowed from Don Manfred's WildCardList program  B4X.com
'	
'	I didn't want to necessary make a library for this routine and I wanted it to be just a single module
'--------------------------------------------------------------------------------------------------------------------------------------
Private Sub ListFilesAndFolders(Path As String, Recursive As Boolean, WildCards As String, Sorted As Boolean, Ascending As Boolean)
			mFilesList.Clear
			mDirectoriesList.Clear
			
			GetDirs(Path, Recursive, WildCards, Sorted, Ascending, True, True)
			
			If  Sorted Then
				mDirectoriesList.SortCaseInsensitive(Ascending)
			End If			
			
			If  Sorted Then
				mFilesList.SortCaseInsensitive(Ascending)
			End If

			LoadScrollView
End Sub

Private Sub GetDirs(Path As String, Recursive As Boolean, WildCards As String, Sorted As Boolean, Ascending As Boolean, vListFiles As Boolean, vListDirs As Boolean)
			
			Dim GetCards() 	As String = Regex.Split(",", WildCards)
  			Dim mask 		As String
			Dim pattern 	As String
			
			For i = 0 To GetCards.Length-1
				GetCards(i) = GetCards(i).Trim
			Next
			
  			If  File.IsDirectory("", Path) Then
				Dim FilesFound As List = File.ListFiles(Path)						'  This line can return an Uninitialized list if Directory NOT Accessable
				
				If  FilesFound.IsInitialized = False Then FilesFound.Initialize		'  This line prevents us from crashing
				
				For i = 0 To FilesFound.Size -1
					If  File.IsDirectory(Path,FilesFound.Get(i)) Then
						If  vListDirs Then
							mDirectoriesList.Add(Path &"/" &FilesFound.Get(i))
						End If
						
						If 	Recursive Then
							GetDirs(Path &"/" &FilesFound.Get(i), Recursive, WildCards, Sorted, Ascending, vListFiles, vListDirs)
						End If
					Else
					    If 	vListFiles Then
							For l = 0 To GetCards.Length -1
			      				Dim TestItem As String = FilesFound.Get(i)
								
								mask = GetCards(l).Trim
								pattern = "^" &mask.Replace(".", "\.").Replace("*", ".+").Replace("?", ".") &"$"
								
								If  Regex.IsMatch(pattern,TestItem) = True Then
									mFilesList.Add(Path &"/" &FilesFound.Get(i))
								End If
			    			Next
						End If
					End If
				Next
			End If
End Sub
#end region
